from machine import Pin,I2C
import ssd1306
import time
from math import sqrt
import random

i2c=I2C(scl=Pin(5),sda=Pin(4))
oled=ssd1306.SSD1306_I2C(128,64,i2c)
x=64
y=2
x_p=[]
y_p=[]
pin=machine.Pin(12,machine.Pin.IN, machine.Pin.PULL_UP)
def circlefull(x,y,r):
    for i in range(128):
        for j in range (64):
            if sqrt((x-i-1)*(x-i-1)+(y-j-1)*(y-j-1)) >r-1 and sqrt((x-i-1)*(x-i-1)+(y-j-1)*(y-j-1)) <r+1:
                    oled.pixel(i,j,1)
def circle(x,y,r):
    for i in range(128):
        for j in range (64):
            if sqrt((x-i-1)*(x-i-1)+(y-j-1)*(y-j-1)) >r-1 and sqrt((x-i-1)*(x-i-1)+(y-j-1)*(y-j-1)) <r+1:
                if i>x and j>y:
                    oled.pixel(i,j,1)
def wkole(x,y,x_l,y_l):
    if sqrt((x-x_l-1)*(x-x_l-1)+(y-y_l-1)*(y-y_l-1)) >60:
        return 1
    if sqrt((x-x_l-1)*(x-x_l-1)+(y-y_l-1)*(y-y_l-1)) <=60:
        return 0
        
oled.rect(x, y, 60, 60, 1)
circle(64,2,60)
w=0
p=0
pi=0
dokladnosc=0
punkty=0
pi_s=str(pi)
dokladnosc_s=str(dokladnosc)
punkty_s=str(punkty)
oled.text("Pi:",0,0,1)
oled.text(pi_s,0,10,1)
oled.text('Points:',0,20,1)
oled.text(punkty_s,0,30,1)
oled.text('Blad:',0,40,1)
oled.text(dokladnosc_s,0,50,1)
oled.show()

while True:
    print(pin.value())
    if pin.value()==0:
        punkty+=1
        oled.fill(0)
        losowy_x=random.getrandbits(8)%60+64
        losowy_y=random.getrandbits(8)%60+2
        x_p.append(losowy_x)
        y_p.append(losowy_y)
        if wkole(x,y,losowy_x,losowy_y)==1:
            w+=1
            print(w)
        if wkole(x,y,losowy_x,losowy_y)==0:
            p+=1
            print(p)
        for i in range(punkty):
            circlefull(x_p[i],y_p[i],1)
        oled.text('Blad:',0,40,1)
        oled.text('Punkty',0,20,1)
        oled.text("Pi:",0,0,1)
        if w>0 and p>0:
            pi=(w/p)*4*3
            dokladnosc=pi/3.14159
        oled.rect(x, y, 60, 60, 1)
        circle(64,2,60)
    pi_s=str(pi)
    dokladnosc_s=str(dokladnosc)
    punkty_s=str(punkty)
    oled.text(punkty_s,0,30,1)
    oled.text(dokladnosc_s,0,50,1)
    oled.text(pi_s,0,10,1)
    oled.show()